unit UfrmMain;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, afParser12, UBoolParser12;

type
  TForm1 = class(TForm)
    BoolParser121: TBoolParser12;
    Label1: TLabel;
    btnCalculate: TButton;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    edtResult: TEdit;
    ComboBox1: TComboBox;
    Label7: TLabel;
    edtA: TEdit;
    edtB: TEdit;
    edtC: TEdit;
    edtD: TEdit;
    cbxTypeA: TComboBox;
    cbxTypeB: TComboBox;
    cbxTypeC: TComboBox;
    cbxTypeD: TComboBox;
    Variable: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    btnClose: TButton;
    Label10: TLabel;
    Label11: TLabel;
    edtExpression: TComboBox;
    procedure btnCalculateClick(Sender: TObject);
    procedure edtExpressionChange(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure btnCloseClick(Sender: TObject);
  private
    FExpressionChanged: boolean;
    FResult: PParserVariant;
    procedure SetParserVars;
    procedure GetParserVars;
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.btnCalculateClick(Sender: TObject);
var
  i: integer;
begin
  if FExpressionChanged then begin
    BoolParser121.ParseExpression(edtExpression.Text);
    FExpressionChanged := False;
  end;
  SetParserVars;
  FResult^ := BoolParser121.Value;
  try
    for i := 2 to BoolParser121.a do begin
      FResult^ := BoolParser121.Value;
    end;
  except
    ;
  end;
  edtResult.Text := FResult^;
  ComboBox1.ItemIndex := GetIndexOfType(ComboBox1.Items, VarType(FResult^));
end;

procedure TForm1.edtExpressionChange(Sender: TObject);
begin
  FExpressionChanged := True;
end;

procedure TForm1.FormShow(Sender: TObject);
begin
  edtA.Text := '6000';
  cbxTypeA.ItemIndex := 1;
  edtB.Text := '';
  cbxTypeB.ItemIndex := 8;
  edtC.Text := DateToStr(Now);
  cbxTypeC.ItemIndex := 5;
  edtD.Text := '';
  cbxTypeD.ItemIndex := 8;
  SetParserVars;
  FResult := BoolParser121.SetVariable('Result', 0);
  FExpressionChanged := False;
end;

procedure TForm1.SetParserVars;
begin
  try
    BoolParser121.A := varEmpty;
    BoolParser121.A := edtA.Text;
    BoolParser121.A := VarAsType(BoolParser121.A, stringtovarType(cbxTypeA.Text));
  except
    BoolParser121.A := '';
  end;
  try
    BoolParser121.B := varEmpty;
    BoolParser121.B := edtB.Text;
    BoolParser121.B := VarAsType(BoolParser121.B, stringtovarType(cbxTypeB.Text));
  except
    BoolParser121.B := '';
  end;
  try
    BoolParser121.C := varEmpty;
    BoolParser121.C := edtC.Text;
    BoolParser121.C := VarAsType(BoolParser121.C, stringtovarType(cbxTypeC.Text));
  except
    BoolParser121.C := '';
  end;
  try
    BoolParser121.D := varEmpty;
    BoolParser121.D := edtD.Text;
    BoolParser121.D := VarAsType(BoolParser121.D, stringtovarType(cbxTypeD.Text));
  except
    BoolParser121.D := '';
  end;
  GetParserVars;
end;

procedure TForm1.GetParserVars;
begin
  cbxTypeA.ItemIndex := GetIndexOfType(cbxTypeA.Items, VarType(BoolParser121.A));
  edtA.Text := BoolParser121.A;
  cbxTypeB.ItemIndex := GetIndexOfType(cbxTypeB.Items, VarType(BoolParser121.B));
  edtB.Text := BoolParser121.B;
  cbxTypeC.ItemIndex := GetIndexOfType(cbxTypeC.Items, VarType(BoolParser121.C));
  edtC.Text := BoolParser121.C;
  cbxTypeD.ItemIndex := GetIndexOfType(cbxTypeD.Items, VarType(BoolParser121.D));
  edtD.Text := BoolParser121.D;
end;

procedure TForm1.btnCloseClick(Sender: TObject);
begin
  Close;
end;

end.
